=encoding utf8

=head1 NAME

Mail::Box::IMAP4::Head - header fields related IMAP interface

=head1 INHERITANCE

 Mail::Box::IMAP4::Head
   is a Mail::Message::Head
   is a Mail::Reporter

=head1 SYNOPSIS

=head1 DESCRIPTION

This class implements a pure IMAP4 protocol interface, where as little
data is retrieved from the header as possible.  This may look nice
to you, but is not sufficient for many tasks.  For instance, you cannot
removed or modify fields this way.

Change L<Mail::Box::IMAP4::new(cache_head)|Mail::Box::IMAP4/"METHODS"> to C<YES> or C<DELAY>, to
get a message header which is capable of performing all possible
games with headers.  On the other hand: the other settings are not
100% safe...

Extends L<"DESCRIPTION" in Mail::Message::Head|Mail::Message::Head/"DESCRIPTION">.

=head1 OVERLOADED

Extends L<"OVERLOADED" in Mail::Message::Head|Mail::Message::Head/"OVERLOADED">.

=over 4

=item overload: B<""> stringifaction

Inherited, see L<Mail::Message::Head/"OVERLOADED">

=item overload: B<bool> true/false

Inherited, see L<Mail::Message::Head/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Message::Head|Mail::Message::Head/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Message::Head|Mail::Message::Head/"Constructors">.

=over 4

=item $class-E<gt>B<build>( [PAIR|$field]-LIST )

Inherited, see L<Mail::Message::Head/"Constructors">

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Message::Head/"Constructors">

 -Option      --Defined in         --Default
  cache_fields                       false
  field_type    Mail::Message::Head  Mail::Message::Field::Fast
  message       Mail::Message::Head  undef
  modified      Mail::Message::Head  false

=over 2

=item cache_fields => BOOLEAN

This is only a read-cache on fields, because this kind of header does
not allow writing of fields.  See L<Mail::Box::IMAP4::new(cache_head)|Mail::Box::IMAP4/"METHODS">,
this value is set to C<false> for C<NO> and C<true> for C<PARTIAL>..

=item field_type => CLASS

=item message => $message

=item modified => BOOLEAN

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Message::Head|Mail::Message::Head/"Attributes">.

=head2 The header

Extends L<"The header" in Mail::Message::Head|Mail::Message::Head/"The header">.

=over 4

=item $obj-E<gt>B<isDelayed>()

Inherited, see L<Mail::Message::Head/"The header">

=item $obj-E<gt>B<isEmpty>()

Inherited, see L<Mail::Message::Head/"The header">

=item $obj-E<gt>B<isModified>()

Inherited, see L<Mail::Message::Head/"The header">

=item $obj-E<gt>B<knownNames>()

Inherited, see L<Mail::Message::Head/"The header">

=item $obj-E<gt>B<message>( [$message] )

Inherited, see L<Mail::Message::Head/"The header">

=item $obj-E<gt>B<modified>( [BOOLEAN] )

Inherited, see L<Mail::Message::Head/"The header">

=item $obj-E<gt>B<orderedFields>()

Inherited, see L<Mail::Message::Head/"The header">

=back

=head2 Access to the header

Extends L<"Access to the header" in Mail::Message::Head|Mail::Message::Head/"Access to the header">.

=over 4

=item $obj-E<gt>B<get>( $name, [$index] )

Get the information about the header line C<$name>.  Realization will
take place.
Improves base, see L<Mail::Message::Head/"Access to the header">

=item $obj-E<gt>B<study>( $name, [$index] )

Inherited, see L<Mail::Message::Head/"Access to the header">

=back

=head2 About the body

Extends L<"About the body" in Mail::Message::Head|Mail::Message::Head/"About the body">.

=over 4

=item $obj-E<gt>B<guessBodySize>()

Inherited, see L<Mail::Message::Head/"About the body">

=item $obj-E<gt>B<isMultipart>()

Inherited, see L<Mail::Message::Head/"About the body">

=back

=head2 Internals

Extends L<"Internals" in Mail::Message::Head|Mail::Message::Head/"Internals">.

=over 4

=item $obj-E<gt>B<addNoRealize>($field)

Inherited, see L<Mail::Message::Head/"Internals">

=item $obj-E<gt>B<addOrderedFields>($fields)

Inherited, see L<Mail::Message::Head/"Internals">

=item $obj-E<gt>B<fileLocation>()

Inherited, see L<Mail::Message::Head/"Internals">

=item $obj-E<gt>B<load>()

Inherited, see L<Mail::Message::Head/"Internals">

=item $obj-E<gt>B<moveLocation>($distance)

Inherited, see L<Mail::Message::Head/"Internals">

=item $obj-E<gt>B<read>($parser)

Inherited, see L<Mail::Message::Head/"Internals">

=item $obj-E<gt>B<setNoRealize>($field)

Inherited, see L<Mail::Message::Head/"Internals">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Message::Head|Mail::Message::Head/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Message::Head|Mail::Message::Head/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DETAILS

Extends L<"DETAILS" in Mail::Message::Head|Mail::Message::Head/"DETAILS">.

=head1 DIAGNOSTICS

=over 4

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=back

=head1 SEE ALSO

This module is part of Mail-Box-IMAP4 version 4.01,
built on December 13, 2025. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2025 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

